using System;
using System.Collections.Generic;
using System.Text;
using Mall.Model.Entity.Miai;
using Mall.Model.Extend.Miai;
using System.Linq;

namespace Mall.Repository.Miai
{
    /// <summary>
    /// 活动评论仓储层
    /// </summary>
    public class RB_Miai_ActivityDiscussRepository : BaseRepository<RB_Miai_ActivityDiscuss>
    {

        /// <summary>
        /// 分页列表
        /// </summary>
        /// <param name="pageIndex">页码</param>
        /// <param name="pageSize">每页显示条数</param>
        /// <param name="rowCount">总条数</param>
        /// <param name="dmodel">查询条件</param>
        /// <returns></returns>
        public List<RB_Miai_ActivityDiscuss_Extend> GetPageList(int pageIndex, int pageSize, out long rowCount, RB_Miai_ActivityDiscuss_Extend dmodel)
        {
            string where = $" 1=1 and d.{nameof(RB_Miai_ActivityDiscuss_Extend.Status)}=0 ";
            if (dmodel.TenantId > 0) {
                where += $@" and d.{nameof(RB_Miai_ActivityDiscuss_Extend.TenantId)}={dmodel.TenantId}";
            }
            if (dmodel.MallBaseId > 0)
            {
                where += $@" and d.{nameof(RB_Miai_ActivityDiscuss_Extend.MallBaseId)}={dmodel.MallBaseId}";
            }
            if (dmodel.ActivityId > 0) {
                where += $@" and d.{nameof(RB_Miai_ActivityDiscuss_Extend.ActivityId)} ={dmodel.ActivityId}";
            }
            if (dmodel.UserId > 0)
            {
                where += $@" and d.{nameof(RB_Miai_ActivityDiscuss_Extend.UserId)} ={dmodel.UserId}";
            }
            if (dmodel.ParentId > 0)
            {
                where += $@" and d.{nameof(RB_Miai_ActivityDiscuss_Extend.ParentId)} ={dmodel.ParentId}";
            }
            if (dmodel.ParentId == -1)
            {
                where += $@" and d.{nameof(RB_Miai_ActivityDiscuss_Extend.ParentId)} =0";
            }
            string sql = $@"select d.*,u.Name as UserName,u.Photo,u1.Name as ReplyUserName from RB_Miai_ActivityDiscuss d
left join rb_member_user u on d.UserId = u.Id
left join rb_member_user u1 on d.ReplyUserId = u1.Id
where {where} order by d.Id asc";
            return GetPage<RB_Miai_ActivityDiscuss_Extend>(pageIndex, pageSize, out rowCount, sql).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Miai_ActivityDiscuss_Extend> GetList(RB_Miai_ActivityDiscuss_Extend dmodel)
        {
            string where = $" 1=1 and {nameof(RB_Miai_ActivityDiscuss_Extend.Status)}=0 ";
            if (dmodel.TenantId > 0)
            {
                where += $@" and {nameof(RB_Miai_ActivityDiscuss_Extend.TenantId)}={dmodel.TenantId}";
            }
            if (dmodel.MallBaseId > 0)
            {
                where += $@" and {nameof(RB_Miai_ActivityDiscuss_Extend.MallBaseId)}={dmodel.MallBaseId}";
            }
            if (dmodel.ActivityId > 0)
            {
                where += $@" and {nameof(RB_Miai_ActivityDiscuss_Extend.ActivityId)} ={dmodel.ActivityId}";
            }
            if (!string.IsNullOrEmpty(dmodel.ActivityIds)) {
                where += $@" and {nameof(RB_Miai_ActivityDiscuss_Extend.ActivityId)} in({dmodel.ActivityIds})";
            }
            if (dmodel.UserId > 0)
            {
                where += $@" and {nameof(RB_Miai_ActivityDiscuss_Extend.UserId)} ={dmodel.UserId}";
            }
            if (dmodel.ParentId > 0)
            {
                where += $@" and {nameof(RB_Miai_ActivityDiscuss_Extend.ParentId)} ={dmodel.ParentId}";
            }
            string sql = $@"select * from RB_Miai_ActivityDiscuss where {where} order by Id asc";
            return Get<RB_Miai_ActivityDiscuss_Extend>(sql).ToList();
        }

        /// <summary>
        /// 获取子集回复 前几条数据
        /// </summary>
        /// <param name="pidsList"></param>
        /// <param name="number"></param>
        /// <returns></returns>
        public List<RB_Miai_ActivityDiscuss_Extend> GetActivityDiscussChildList(List<int> pidsList, int number)
        {
            int count = pidsList.Count();
            string sql = "";
            if (count == 1) {
                //只有一条数据
                sql = $@"select d.*,u.Name as UserName,u.Photo,u1.Name as ReplyUserName from RB_Miai_ActivityDiscuss d
left join rb_member_user u on d.UserId = u.Id
left join rb_member_user u1 on d.ReplyUserId = u1.Id
where d.Status =0 and d.ParentId ={pidsList.FirstOrDefault()} order by d.Id asc limit {number}";
            }
            for (var i = 0; i < count; i++) {
                if (i == count - 1)
                {
                    //最后一条
                    sql += $@"(select d.*,u.Name as UserName,u.Photo,u1.Name as ReplyUserName from RB_Miai_ActivityDiscuss d
left join rb_member_user u on d.UserId = u.Id
left join rb_member_user u1 on d.ReplyUserId = u1.Id
where d.Status =0 and d.ParentId ={pidsList[i]} order by d.Id asc limit {number})";
                }
                else {
                    sql += $@"(select d.*,u.Name as UserName,u.Photo,u1.Name as ReplyUserName from RB_Miai_ActivityDiscuss d
left join rb_member_user u on d.UserId = u.Id
left join rb_member_user u1 on d.ReplyUserId = u1.Id
where d.Status =0 and d.ParentId ={pidsList[i]} order by d.Id asc limit {number})
union 
";
                }
            }
            return Get<RB_Miai_ActivityDiscuss_Extend>(sql).ToList();
            
        }

        /// <summary>
        /// 获取回复数量
        /// </summary>
        /// <param name="activityIds"></param>
        /// <returns></returns>
        public List<RB_Miai_ActivityDiscuss_Extend> GetActivityReplyNumList(string activityIds)
        {
            string sql = $@"select ActivityId,count(0) as ReplyNum from RB_Miai_ActivityDiscuss where Status =0 and ActivityId in({activityIds}) group by ActivityId";
            return Get<RB_Miai_ActivityDiscuss_Extend>(sql).ToList();
        }

        /// <summary>
        /// 获取评论回复数量
        /// </summary>
        /// <param name="pids"></param>
        /// <returns></returns>
        public List<RB_Miai_ActivityDiscuss_Extend> GetDiscussReplyNumList(string pids)
        {
            string sql = $@"select ParentId,count(0) as ReplyNum from RB_Miai_ActivityDiscuss where Status =0 and ParentId in({pids}) group by ParentId";
            return Get<RB_Miai_ActivityDiscuss_Extend>(sql).ToList();
        }
    }
}
